{{- define "libdjango.worker-deployment.tpl" }}
{{- $labels := include "libdjango.labels" . -}}
{{- $versionLabels := include "libdjango.versionLabels" . -}}
{{- range .Values.celeryWorker.queues -}}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: "{{ $.Release.Name }}-celery-worker-{{ .name }}"
  labels:
    {{- $labels | nindent 4 }}
    app.kubernetes.io/component: "celery-worker-{{ .name }}"
spec:
  replicas: {{ .replicaCount }}
  selector:
    matchLabels:
      {{- $labels | nindent 6 }}
      app.kubernetes.io/component: "celery-worker-{{ .name }}"
  strategy:
    type: Recreate
  template:
    metadata:
      labels:
        {{- $labels | nindent 8 }}
        {{- $versionLabels | nindent 8 }}
        app.kubernetes.io/component: "celery-worker-{{ .name }}"
      annotations: { }
    spec:
      {{- with $.Values.image.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      securityContext:
        {{- toYaml .podSecurityContext | nindent 8 }}
      containers:
        - name: {{ $.Chart.Name }}-celery-worker-{{ .name }}
          securityContext:
            {{- toYaml .securityContext | nindent 12 }}
          image: "{{ $.Values.image.repository }}:{{ $.Values.image.tag | default $.Chart.AppVersion }}"
          imagePullPolicy: {{ $.Values.image.pullPolicy }}
          {{- with .command }}
          command:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          envFrom:
            - configMapRef:
                name: "{{ $.Release.Name }}-config"
            - secretRef:
                name: "{{ $.Release.Name }}-secrets"
          resources:
            {{- toYaml .resources | nindent 12 }}
      {{- with .nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
---
  {{- end -}}
{{- end }}
{{- define "libdjango.worker-deployment" -}}
{{- include "libdjango.merge" (append . "libdjango.worker-deployment.tpl") -}}
{{- end -}}
